
package rice.p2p.replication.messaging;

import rice.p2p.commonapi.*;
import rice.p2p.replication.*;

/**
 * @(#) ReaponseMessage.java
 *
 * This class represents a response for a set of keys in the replication
 * system.
 *
 * @version $Id: ResponseMessage.java 2302 2005-03-11 00:58:26Z jeffh $
 *
 * @author Alan Mislove
 */
public class ResponseMessage extends ReplicationMessage {
  
  // the list of ranges for this message
  protected IdRange[] ranges;
  
  // the list of keys for this message
  protected IdSet[] ids;
  
  /**
  * Constructor which takes a unique integer Id
   *
   * @param source The source address
   * @param topic The topic
   */
  public ResponseMessage(NodeHandle source, IdRange[] ranges, IdSet[] ids) {
    super(source);
    
    this.ranges = ranges;
    this.ids = ids;
  }
  
  /**
   * Method which returns this messages' ranges
   *
   * @return The ranges of this message
   */
  public IdRange[] getRanges() {
    return ranges;
  }
  
  /**
   * Method which returns this messages' ranges
   *
   * @return The ranges of this message
   */
  public IdSet[] getIdSets() {
    return ids;
  }
  
}

